using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

namespace PageBox
{
	/// <summary>
	/// <p>Deployment Web Service.<br/>
	/// Invoked by Repository.</p>
	/// <p>Copyright (c) 2002 Alexis Grandemange<br/>
	/// Mail: alexis.grandemange@pagebox.net</p>
	/// <pre>This program is free software; you can redistribute it and/or
	/// modify it under the terms of the GNU Lesser General Public
	/// License as published by the Free Software Foundation; version
	/// 2.1 of the License.
	/// This library is distributed in the hope that it will be useful,
	/// but WITHOUT ANY WARRANTY; without even the implied warranty of
	/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	/// GNU Lesser General Public License for more details.
	/// A copy of the GNU Lesser General Public License lesser.txt should be
	/// included in the distribution.</pre>
	/// </summary>
	[WebService(Namespace="PageBox")]
	public class Deploy : System.Web.Services.WebService
	{
		public Deploy()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}
		#endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
		}

		/// <summary>
		/// Deploys an archive and returns a status.
		/// </summary>
		/// <param name="arch">archive name</param>
		/// <param name="downloadURL">download URL</param>
		/// <param name="owner">user who published the archive</param>
		/// <param name="size">archive size</param>
		/// <param name="date">publication date and time</param>
		/// <param name="docURL">documentation URL</param>
		/// <param name="user">user who requested the deploy</param>
		[WebMethod]
		public string add(string arch, string downloadURL, string owner, int size,
			DateTime date, string docURL, string user)
		{
			string rc = Global.pbArchives.add(arch, downloadURL, owner, size, date, docURL);
			Log.write(user, Context.Request.ServerVariables["REMOTE_HOST"],
				"Deploy.add(" + arch + ", " + owner + ", " + downloadURL + ") returned " + rc);
			return rc;
		}

		/// <summary>
		/// Undeploys an archive and returns a status.
		/// </summary>
		/// <param name="arch">archive name</param>
		/// <param name="downloadURL">download URL</param>
		/// <param name="owner">user who published the archive</param>
		/// <param name="user">user who requested the undeploy</param>
		[WebMethod]
		public string delete(string arch, string downloadURL, string owner, string user) 
		{
			string rc = Global.pbArchives.delete(arch, downloadURL, owner);
			Log.write(user, Context.Request.ServerVariables["REMOTE_HOST"],
				"Deploy.delete(" + arch + ", " + owner + ", " + downloadURL + ") returned " + rc);
			return rc;
		}
	}
}
